﻿define(['ojs/ojcore', 'knockout', 'ojs/ojmodel'],
       function(oj, ko)
       {
           function viewModel() 
           {
                var self = this;
                self.serviceURL = 'http://localhost/services/rest/vxdemo/ContactsWorkScreen/data/contacts';
                self.dataSource = ko.observable(); 
                self.ContactsCollection = ko.observable();
                
                self.myBasicAuth = function() {};
                self.myBasicAuth.prototype.getHeader = function ()
                {
                    var headers = {};
                 	headers['Authorization'] = 'Basic ' + btoa("admin:admin");
                    
                    return headers;
                };
                
                parseContact = function(response) 
                {
                    return {ID: response['ID'],
                            FIRSTNAME: response['FIRSTNAME'],
                            LASTNAME:response['LASTNAME']};
                };

                // Think of this as a single database record or a single table row.
                var Contact = oj.Model.extend(
                {
                    urlRoot: self.serviceURL,
                    parse: parseContact,
                    idAttribute: 'ID'
                });
    
                var myContact = new Contact();
                
                var ContactsCollection = oj.Collection.extend(
                {
                    url: self.serviceURL,
                    model: myContact,
                    oauth: new self.myBasicAuth(),
                    comparator: "ID"
                });
                
                self.ContactsCollection(new ContactsCollection());
                
                //simple request test
                //self.ContactsCollection().fetch({headers: {"Authorization": 'Basic ' + btoa("admin:admin")}});
                
                self.dataSource(new oj.CollectionTableDataSource(self.ContactsCollection()));
                
           }

           return {'contactsVM': viewModel};
        }
    );

